{{ SayItAlpha110609b.spin
  (Created using Board u)
  Modified from MecanumRemote110603a.spin

  110604a Start making a driver for the
  Parallax Say It Module.  110605a test
  skeleton program.  5a doesn't work.
  Say only returns $FF.  b switch tx and
  rx.  b works to wake up Say It but that's
  all it does.  c add ability to same
  parameters to EEPROM.
  f the terminal showed
  "Say It returned =s
  Say It returned =A "
  After I said "robot".  But only once.
  Partial success.
  06d Allow bridge to share debug line.
  Switch serial driver to non-flag version.
  e remove any zeros from received characters.
  I added a pull-up resistor on P27.  It might
  have made things worse.
  09b The voice part works okay.
  Remember to wake the robot up.
  The bridge through the debug line doesn't
  seem to work.

  Goals of driver.
  Display verbal commands received by Say It
  Module on the terminal.
  Be able to program module with terminal menu
  items.
 
}}
{{  Copied from "Say It Demo.bs2"
' Protocol Command
CMD_BREAK           CON         "b" ' abort recog or ping
CMD_SLEEP           CON         "s" ' go to power down
CMD_KNOB            CON         "k" ' set si knob <1>
CMD_LEVEL           CON         "v" ' set sd level <1>
CMD_LANGUAGE        CON         "l" ' set si language <1>
CMD_TIMEOUT         CON         "o" ' set timeout <1>
CMD_RECOG_SI        CON         "i" ' do si recog from ws <1>
CMD_RECOG_SD        CON         "d" ' do sd recog at group <1> (0 = trigger mixed si/sd)

' Protocol Status
STS_AWAKEN          CON         "w" ' back from power down mode
STS_ERROR           CON         "e" ' signal error code <1-2>
STS_INVALID         CON         "v" ' invalid command or argument
STS_TIMEOUT         CON         "t" ' timeout expired
STS_INTERR          CON         "i" ' back from aborted recognition (see 'break')
STS_SUCCESS         CON         "o" ' no errors status
STS_RESULT          CON         "r" ' recognised sd command <1> - training similar to sd <1>
STS_SIMILAR         CON         "s" ' recognised si <1> (in mixed si/sd) - training similar to si <1>

' Protocol arguments are in the range 0x40 (-1) TO 0x60 (+31) inclusive
ARG_MIN             CON         64 ' 0x40
ARG_MAX             CON         96 ' 0x60
ARG_ZERO            CON         65 ' 0x41

ARG_ACK             CON         32 ' 0x20    'TO READ more status arguments

' Wordset
WST                 CON         0  ' wordset trigger
WS1                 CON         1  ' Wordset 1 commands
WS2                 CON         2  ' Wordset 2 actions
WS3                 CON         3  ' Wordset 3 numbers

'Wordset Commands
WS1_Action          CON   0
WS1_Move            CON   1
WS1_Turn            CON   2
WS1_Run             CON   3
WS1_Look            CON   4
WS1_Attack          CON   5
WS1_Stop            CON   6
WS1_Hello           CON   7

WS2_Left            CON   0
WS2_Right           CON   1
WS2_Up              CON   2
WS2_Down            CON   3
WS2_Forward         CON   4
WS2_Backward        CON   5

WS3_Zero            CON   0
WS3_One             CON   1
WS3_Two             CON   2
WS3_Three           CON   3
WS3_Four            CON   4
WS3_Five            CON   5
WS3_Six             CON   6
WS3_Seven           CON   7
WS3_Eight           CON   8
WS3_Nine            CON   9
WS3_Ten             CON   10

WS_Timeout          CON   254
WS_Error            CON   255

VAR_LANG            DATA 0
VAR_KNOB            DATA 2
VAR_LEVEL           DATA 2


'Robot Constant
COMMAND_DURATION    CON   2000
COMMAND_SPEED_HIGH  CON   3
COMMAND_SPEED_LOW   CON   1

'Global Variable
counter             VAR   Word
VRA                 VAR   Byte
VRA1                VAR   Byte
VRLED               VAR   Byte
WS                  VAR   Byte
RXC                 VAR   Byte
RXC_PREV            VAR   Byte
}}
CON

  ' Copied from "Say It Demo.bs2"
  ' Protocol Command
  CMD_BREAK = "b" ' abort recog or ping
  CMD_SLEEP = "s" ' go to power down
  CMD_KNOB = "k" ' set si knob <1>
  CMD_LEVEL = "v" ' set sd level <1>
  CMD_LANGUAGE = "l" ' set si language <1>
  CMD_TIMEOUT = "o" ' set timeout <1>
  CMD_RECOG_SI = "i" ' do si recog from ws <1>
  CMD_RECOG_SD = "d" ' do sd recog at group <1> (0 = trigger mixed si/sd)
  CMD_ID = "x"
  CMD_DUMP_SD = "p"
  CMD_MASK_SD = "m"
  CMD_COUNT_SD = "c"
  
  ' Protocol Status
  STS_AWAKEN = "w" ' back from power down mode
  STS_ERROR = "e" ' signal error code <1-2>
  STS_INVALID = "v" ' invalid command or argument
  STS_TIMEOUT = "t" ' timeout expired
  STS_INTERR = "i" ' back from aborted recognition (see 'break')
  STS_SUCCESS = "o" ' no errors status
  STS_RESULT = "r" ' recognised sd command <1> - training similar to sd <1>
  STS_SIMILAR = "s" ' recognised si <1> (in mixed si/sd) - training similar to si <1>
 
  ' Protocol arguments are in the range 0x40 (-1) TO 0x60 (+31) inclusive
  ARG_MIN = 64 ' 0x40
  ARG_MAX = 96 ' 0x60
  ARG_ZERO = 65 ' 0x41
   
  ARG_ACK = 32 ' 0x20    'TO READ more status arguments
   
  ' Wordset
  WST = 0  ' wordset trigger
  WS1 = 1  ' Wordset 1 commands
  WS2 = 2  ' Wordset 2 actions
  WS3 = 3  ' Wordset 3 numbers
   
  'Wordset Commands
  WS1_Action = 0
  WS1_Move = 1
  WS1_Turn = 2
  WS1_Run = 3
  WS1_Look = 4
  WS1_Attack = 5
  WS1_Stop = 6
  WS1_Hello = 7
   
  WS2_Left = 0
  WS2_Right = 1
  WS2_Up = 2
  WS2_Down = 3
  WS2_Forward = 4
  WS2_Backward = 5
   
  WS3_Zero = 0
  WS3_One = 1
  WS3_Two = 2
  WS3_Three = 3
  WS3_Four = 4
  WS3_Five = 5
  WS3_Six = 6
  WS3_Seven = 7
  WS3_Eight = 8
  WS3_Nine = 9
  WS3_Ten = 10
   
  WS_Timeout = 254
  WS_Error = 255
{
VAR_LANG            DATA 0
VAR_KNOB            DATA 2
VAR_LEVEL           DATA 2
}

  'Robot Constant
  COMMAND_DURATION = 2000
  COMMAND_SPEED_HIGH = 3
  COMMAND_SPEED_LOW = 1

  ' language enumeration
  #0, _English, _Italian, _Japanese, _German  
   
CON

  _Clkmode = xtal1 + pll16x     ' 80MHz  Change these two settings to match
  _Xinfreq = 5_000_000          ' your setup.


  ' Pin Assignments
  _SayItLed = 15                  ' Connected to Led on Say It

  _BridgeTxPin = 9 '28 '-1 '            ' use -1 if the bridge shares the debug line
  _BridgeRxPin = 8 '29 '-1 '            ' use -1 if the bridge shares the debug line
  
  _SayItTx = 27                 ' Connected to Rx on Say It
  _SayItRx = 26'8                 ' Connected to Tx on Say It 
  _DebugTxPin = 30
  _DebugRxPin = 31

  
  _SayItBaud = 9600
  _DebugBaud = _SayItBaud '57600 

  _LargeBufferSize = 32
  _WordsetLabelSize = 9
  _DefaultWakeAttempts = 8
  _WordsetAttempts = 8
  _TxDelay = 80_000
  _ISetSize0 = 1
  _ISetSize1 = 8
  _ISetSize2 = 6
  _ISetSize3 = 11
  _EepromBegin = $4A00    '******** check this with each change
  _EepromEnd = $FFFF
  _RamBufferSize = 100
  _MaxLoopChars = 10
  _EepromTriggerSize = _RamBufferSize - _MaxLoopChars
  
  ' communication enumeration
  #0, _SayItCom, _DebugCom, _BridgeCom

  ' mode enumeration
  #0, _ListenForWordSet0, _ListenForWordSet1, _ListenForWordSet2, {
    } _ListenForWordSet3, _NotListening, _ListenForWordSet3Hundreds,  _ListenForWordSet3tens, {
    } _ListenForWordSet3units, _TrainSDGroup0 
    
  ' word set enumeration
  #0, _TiggerWs0, _TypeWs1, _DirectionWs2, _AmountWs3, _NotListeningWs4

  ' wordset1 enumeration
  #0, _ActionWs1, _MoveWs1, _TurnWs1, _RunWs1, _LookWs1, _AttackWs1, _StopWs1, _HelloWs1

  ' wordset2 enumeration
  #0, _LeftWs2, _RightWs2, _UpWs2, _DownWs2, _ForwardWs2, _BackwardWs2

  ' wordset3 enumeration
  #0, _ZeroWs3, _OneWs3, _TwoWs3, _ThreeWs3, _FourWs3, _FiveWs3, _SixWs3, _SevenWs3, _EightWs3, _NineWs3, _TenWs3

  ' next action enumeration
  #0, _NoActionNext, _ActionNext, _MoveLeftNext, _MoveRightNext, _MoveUpNext, _MoveDownNext, {
    } _MoveForwardNext, _MoveBackwardNext, _TurnLeftNext, _TurnRightNext, _TurnUpNext, {
    } _TurnDownNext, _TurnForwardNext, _TurnBackwardNext, _RunNext, _LookLeftNext, {
    } _LookRightNext, _LookUpNext, _LookDownNext, _LookForwardNext, _LookBackwardNext, {
    } _AttackLeftNext, _AttackRightNext, _AttackUpNext, _AttackDownNext, {
    } _AttackForwardNext, _AttackBackwardNext, _StopNext, _HelloNext

VAR
 
  long cog, eepromIndex

  long wordset3Total

  word globalCounter

  {{
  'Global Variable
counter             VAR   Word
VRA                 VAR   Byte
VRA1                VAR   Byte
VRLED               VAR   Byte
WS                  VAR   Byte
RXC                 VAR   Byte
RXC_PREV            VAR   Byte
  }}
  byte vra, vra1, vrLed, ws, rxc, rxcPrevious
  byte currentWordset, previousWordGroup, globalMode, previousGlobalMode
  byte previousIndex, priorPreviousIndex, wordset3DigitRemaining, nextAction 
  byte bridgeComPort, ramIndex, eepromFlag
  byte eepromBuffer[_RamBufferSize], similarFlag 
  
OBJ

  Com : "pcFullDuplexSerial4FC128"                 ' uses one cog
  Eeprom : "Propeller EepromDWD"
  
PUB Main | localIndex, localAttmpts

  globalMode := _NotListening 
  nextAction := _NoActionNext
  currentWordset := _NotListeningWs4
  previousWordGroup := _NotListeningWs4
              
  outa[_SayItLed]~  
  dira[_SayItLed]~~  
  
 
  Com.AddPort(_SayItCom, _SayItRx, _SayItTx, -1, -1, 0, 0, _SayItBaud)
  if _BridgeTxPin == -1 and _BridgeRxPin == -1 
    bridgeComPort := _DebugCom
    Com.AddPort(_DebugCom, _DebugRxPin, _DebugTxPin, -1, -1, 0, 0, _SayItBaud)
  else 
    bridgeComPort := _BridgeCom
    Com.AddPort(_DebugCom, _DebugRxPin, _DebugTxPin, -1, -1, 0, 0, _DebugBaud)
    Com.AddPort(_BridgeCom, _BridgeRxPin, _BridgeTxPin, -1, -1, 0, 0, _SayItBaud)
             
  Com.Start
   
  Tbug(string(13, "Com driver started"))
  if eepromIndex == 0
    eepromIndex := _EepromBegin
    Eeprom.FromRam(@eepromIndex, @eepromIndex + 3, @eepromIndex)
    eepromFlag := 0
  elseif (_EepromEnd - _MaxLoopChars) =< eepromIndex
    eepromFlag := 2
    Tbug(string(13, 13, "EEPROM is full.  Please delete before recording.", 13))
  else 
    eepromFlag := 0
    Tbug(string(13, 13, "EEPROM has "))
    TbugDec(eepromIndex - _EepromBegin) 
    Tbug(string(" bytes written to it."))
    Tbug(string(13, "There are still "))
    TbugDec(_EepromEnd - eepromIndex) 
    Tbug(string(" empty bytes in the EEPROM.", 13))
    
  repeat
    Tbug(string(13, "Press any key to start"))
    localIndex := Com.rxcheck(_DebugCom)
    waitcnt(clkfreq / 10 + cnt)
  while localIndex == -1
  TbugTx(13)
  TbugTx(13)
  'TbugTx(13)
  'TbugTx(13)
  'Tbug(string(13, "Waking up Say It Module"))
  {
  localIndex := 0
  localAttmpts := 0
  repeat
    localIndex := WakeUp 
    Tbug(string(13, "Wake attempt #"))
    TbugDec(++localAttmpts)
    Tbug(string(13, "Say It returned ="))
    TbugTx(localIndex)
    if localIndex == STS_SUCCESS
      Tbug(string(13, "The Say It Module is now awake."))
    else
      Tbug(string(13, "Wake attempt #"))
      TbugDec(localAttmpts)
      Tbug(string(" failed."))
      waitcnt(clkfreq / 10 + cnt)  
  while localAttmpts =< _DefaultWakeAttempts and localIndex <> STS_SUCCESS

  if localIndex <> STS_SUCCESS
    Tbug(string(13, "The Say It Module failed to awake."))
    'Tbug(string(13, "Please check connections are restart program."))
    'Tbug(string(13, 13, 13, "End of program."))
    'repeat
      'waitcnt(cnt)  ' reduce power but keep Prop on
  Tbug(string(13, "Initializing Say It Module"))
  localIndex := Init
  Tbug(string(13, "Init method returned "))
  TbugDec(localIndex)    
  Tbug(string(" errors."))
  }
  MainLoop
  
PUB MainLoop | localCharacter, loopCounter, localIndex, {
             } localAttmpts, localSize

  loopCounter := 0
  similarFlag := 0         ' this is set to one when the next
                                ' character read in should be a
                                ' wordset index number.
  'localFlag := 1                              
  DisplayTopMenu
  
  repeat
  
    'waitcnt(_DefaultLoopDelay + cnt)
    
    loopCounter++
    {if localFlag <> 0
      DisplayTopMenu
      Tbug(string(13, 13, "globalMode ="))
      TbugDec(globalMode)
      Tbug(string(13, "loopCounter ="))
      TbugDec(loopCounter)
      localFlag := 0 }
    localCharacter := Com.rxcheck(_SayItCom)
    if localCharacter <> -1 and localCharacter <> 0
      Tbug(string(13, "Say It returned ="))
      TbugTx(localCharacter)
      Com.Tx(_SayItCom, 32)     ' enter space character to Say It to read next byte
      if similarFlag == 1
        FindBranch(localCharacter)
        similarFlag := 0 
      elseif localCharacter == STS_SIMILAR
        similarFlag := 1
      elseif localCharacter == STS_TIMEOUT
        Tbug(string(13, "Timeout error was returned."))
        similarFlag := 0
        if currentWordset <> _NotListeningWs4
          Tbug(string(13, "Say It is no longer listening for wordset #"))
          TbugDec(currentWordset)
          currentWordset := _NotListeningWs4
      elseif localCharacter == STS_ERROR
        Tbug(string(13, "An error was returned."))
        similarFlag := 0
        if currentWordset <> _NotListeningWs4
          Tbug(string(13, "Say It may no longer be listening for wordset #"))
          TbugDec(currentWordset)
          currentWordset := _NotListeningWs4
          
    localCharacter := Com.rxcheck(_DebugCom)
    if localCharacter <> -1 and localCharacter <> 0
      case localCharacter
        "x", "m", "c", "p": Request(localCharacter)

        "b":
          localIndex := eepromIndex
          Bridge
          if eepromFlag == 1
            Tbug(string(13, "You are still in record mode."))
            Tbug(string(13, "Play back session to exit record mode."))
            if localIndex == eepromIndex
              Tbug(string(13, "No data was recorded to EEPROM."))
            else
              Tbug(string(13, "There were "))
              TbugDec(eepromIndex - localIndex)  
              Tbug(string(" byte written to EEPROM."))
              Tbug(string(13, "Making a total of "))
              TbugDec(eepromIndex - _EepromBegin) 
              Tbug(string(" bytes written to EEPROM."))
              Tbug(string(13, "There are still "))
              TbugDec(_EepromEnd - eepromIndex) 
              Tbug(string(" empty bytes in the EEPROM.", 13))
              Eeprom.FromRam(@eepromIndex, @eepromIndex + 3, @eepromIndex)  
        "u":
          result := bridgeComPort
          bridgeComPort := _DebugCom
          Tbug(string(13, "Using debug commmunication line"))
          Tbug(string(13, "as the bridge line to the Say It GUI."))
          localIndex := eepromIndex         
          Bridge
          if eepromFlag == 1
            Tbug(string(13, "You are still in record mode."))
            Tbug(string(13, "Play back session to exit record mode."))
            if localIndex == eepromIndex
              Tbug(string(13, "No data was recorded to EEPROM."))
            else
              Tbug(string(13, "There were "))
              TbugDec(eepromIndex - localIndex)  
              Tbug(string(" byte written to EEPROM."))
              Tbug(string(13, "Making a total of "))
              TbugDec(eepromIndex - _EepromBegin) 
              Tbug(string(" bytes written to EEPROM."))
              Tbug(string(13, "There are still "))
              TbugDec(_EepromEnd - eepromIndex) 
              Tbug(string(" empty bytes in the EEPROM.", 13))
              Eeprom.FromRam(@eepromIndex, @eepromIndex + 3, @eepromIndex) 
          bridgeComPort := result
        "r":
          if eepromFlag == 2
            Tbug(string(13, "EEPROM is full."))
            Tbug(string(13, "Unable to enter record mode."))
            Tbug(string(13, "Please delete EEPROM data and try again."))
          else
            Tbug(string(13, "You are now in record mode."))
            eepromFlag := 1
            Tbug(string(13, 13, "EEPROM has "))
            TbugDec(eepromIndex - _EepromBegin) 
            Tbug(string(" bytes written to it."))
            Tbug(string(13, "There are still "))
            TbugDec(_EepromEnd - eepromIndex) 
            Tbug(string(" empty bytes in the EEPROM.", 13))
        "s":
          Tbug(string(13, "Displaying data from EEPROM."))
          Tbug(string(13, "Record mode is off."))
          eepromFlag := 0
          if eepromIndex == _EepromBegin
            Tbug(string(13, "EEPROM is currently empty."))   
          else
            Tbug(string(13, "Ready to display "))
            TbugDec(eepromIndex - _EepromBegin) 
            Tbug(string(" bytes from EEPROM."))
            localIndex := _EepromBegin
            repeat
              if (eepromIndex - localIndex) < _RamBufferSize
                localSize := eepromIndex - localIndex
              else
                localSize := _RamBufferSize               
              Eeprom.ToRam(@eepromBuffer, @eepromBuffer + localSize - 1, localIndex)
              SafeBug(@eepromBuffer, localSize)
              localIndex += localSize
            while localIndex < eepromIndex
            
        "e":
          eepromIndex := _EepromBegin
          Eeprom.FromRam(@eepromIndex, @eepromIndex + 3, @eepromIndex) 
          Tbug(string(13, "Resetting EEPROM pointer."))
          Tbug(string(13, "Record mode is off."))
          eepromFlag := 0
          
          
        "w":
          localIndex := 0
          localAttmpts := 0
          repeat
            localIndex := WakeUp 
            Tbug(string(13, "Wake attempt #"))
            TbugDec(++localAttmpts)
            Tbug(string(13, "Say It returned ="))
            TbugTx(localIndex)
            if localIndex == STS_SUCCESS
              Tbug(string(13, "The Say It Module is now awake."))
            else
              Tbug(string(13, "Wake attempt #"))
              TbugDec(localAttmpts)
              Tbug(string(" failed."))
              waitcnt(clkfreq / 10 + cnt)  
          while localAttmpts =< _DefaultWakeAttempts and localIndex <> STS_SUCCESS
        "i":
          Tbug(string(13, "Initializing Say It Module"))
          localIndex := Init
          Tbug(string(13, "Init method returned "))
          TbugDec(localIndex)    
          Tbug(string(" errors."))
        "d":
          DisplayTopMenu
        "o":
          SetTimeout
          Tbug(string(13, "Initializing Say It Module"))
          localIndex := Init
          Tbug(string(13, "Init method returned "))
          TbugDec(localIndex)    
          Tbug(string(" errors."))
        "g":
          if bridgeComPort == _BridgeCom
            Tbug(string(13, "The bridge is not using the same IO pins"))
            Tbug(string(13, "as the debug line to communicate with computer."))
            Tbug(string(13, "bridge rx pin = "))  
            TbugDec(_BridgeRxPin)
            Tbug(string(13, "bridge tx pin = "))  
            TbugDec(_BridgeTxPin)            
          else
            Tbug(string(13, "The bridge is using the same IO pins as"))
            Tbug(string(13, "the debug line to communicate with computer."))
            Tbug(string(13, "Shared debug/bridge rx pin = "))
            TbugDec(_DebugRxPin)
            Tbug(string(13, "Shared debug/bridge tx pin = "))
            TbugDec(_DebugTxPin)
        "t":
          Tbug( string(13, "Say It is now listening for trigger."))
          SetListeningMode(_TiggerWs0)
        other:
          Tbug( string(13, 34)) 
          TbugTx(localCharacter) 
          Tbug( string(" was entered.  Which is not a menu choice.")) 
      DisplayTopMenu
    
    'Tbug(string(" loopCounter = "))
    'TbugDec(loopCounter)
    'TbugTx(13)
{ Tbug( string(13, "Enter ", 34, "d", 34, " to display this menu.")) 
  Tbug( string(13, "Enter ", 34, "w", 34, " to wake up Say It module.")) 
  Tbug( string(13, "Enter ", 34, "i", 34, " to initialize Say It module.")) 
  Tbug( string(13, "Enter ", 34, "x", 34, " to request firmware ID of module.")) 
  Tbug( string(13, "Enter ", 34, "o", 34, " to set timeout of module.")) 
  Tbug( string(13, "Enter ", 34, "m", 34, " to request non-empty groups of module.")) 
  Tbug( string(13, "Enter ", 34, "c", 34, " to request count of speaker dependent commands.")) 
  Tbug( string(13, "Enter ", 34, "p", 34, " to request speaker dependent commands of module.")) 
  Tbug( string(13, "Enter ", 34, "b", 34, " to enter bridge module. (To use Say It GUI.)")) 
  Tbug( string(13, "Enter ", 34, "u", 34, " to use debug line for bridge to GUI.")) 
  Tbug( string(13, "Enter ", 34, "r", 34, " to record bridge session to EEPROM.*")) 
  Tbug( string(13, "Enter ", 34, "s", 34, " to play back bridge session from EEPROM.")) 
  Tbug( string(13, "Enter ", 34, "e", 34, " to erase EEPROM recording.*")) 
  Tbug( string(13, "Enter ", 34, "g", 34, " to show IO pins used for bridge to GUI.")) 
  Tbug( string(13, "Enter ", 34, "t", 34, " to have Say It listen for trigger.")) 
  TbugTx(13)
  Tbug( string(13, "Items marked with an ", 34, "*", 34, " will likely write to your EEPROM.")) 
  Tbug( string(13, "(only once in the same place per selection)")) 
  Tbug( string(13, "The erase EEPROM command just resets a pointer.")) 
  Tbug( string(13, "The EEPROM location of the variable holding the pointer")) 
  Tbug( string(13, "is written to once per selection.")) 
  
' word group enumeration
  #0, _TiggerWs0, _TypeWs1, _DirectionWs2, _AmountWs3, _NotListeningWs4
}
PUB DisplayTopMenu | localIndex, localWordSet, localPtr

  localWordSet := globalMode - _ListenForWordSet0
  if globalMode <> _NotListening 
    Tbug( string(13, "You many now speak commands to the Say It Module"))
    Tbug( string(13, "The current active wordset is "))
    
    case globalMode
      _ListenForWordSet0, _ListenForWordSet1, _ListenForWordSet2, _ListenForWordSet3:
        case localWordSet
          0: localPtr := @iWordset0
            Tbug( string("the Tigger or "))
          1: localPtr := @iWordset1
          2: localPtr := @iWordset2
          3: localPtr := @iWordset3
        Tbug( string("Wordset "))
        TbugDec(localWordSet)
        TbugTx(":")
        repeat localIndex from 0 to iSetSize[localWordSet] - 1
          TbugTx(13)
          TbugDec(localIndex)
          TbugTx(32)
          TbugTx(32)
          TbugTx(32)
          Tbug(localPtr + (localIndex * _WordsetLabelSize))      
  TbugTx(13)
  TbugTx(13)
  Tbug( string(13, "Enter ", 34, "d", 34, " to display this menu.")) 
  Tbug( string(13, "Enter ", 34, "w", 34, " to wake up Say It module.")) 
  Tbug( string(13, "Enter ", 34, "i", 34, " to initialize Say It module.")) 
  Tbug( string(13, "Enter ", 34, "x", 34, " to request firmware ID of module.")) 
  Tbug( string(13, "Enter ", 34, "o", 34, " to set timeout of module.")) 
  Tbug( string(13, "Enter ", 34, "m", 34, " to request non-empty groups of module.")) 
  Tbug( string(13, "Enter ", 34, "c", 34, " to request count of speaker dependent commands.")) 
  Tbug( string(13, "Enter ", 34, "p", 34, " to request speaker dependent commands of module.")) 
  Tbug( string(13, "Enter ", 34, "b", 34, " to enter bridge module. (To use Say It GUI.)")) 
  Tbug( string(13, "Enter ", 34, "u", 34, " to use debug line for bridge to GUI.")) 
  Tbug( string(13, "Enter ", 34, "r", 34, " to record bridge session to EEPROM.*")) 
  Tbug( string(13, "Enter ", 34, "s", 34, " to play back bridge session from EEPROM.")) 
  Tbug( string(13, "Enter ", 34, "e", 34, " to erase EEPROM recording.*")) 
  Tbug( string(13, "Enter ", 34, "g", 34, " to show IO pins used for bridge to GUI.")) 
  Tbug( string(13, "Enter ", 34, "t", 34, " to have Say It listen for trigger.")) 
  TbugTx(13)
  Tbug( string(13, "Items marked with an ", 34, "*", 34, " will likely write to your EEPROM.")) 
  Tbug( string(13, "(only once in the same place per selection)")) 
  Tbug( string(13, "The erase EEPROM command just resets a pointer.")) 
  Tbug( string(13, "The EEPROM location of the variable holding the pointer")) 
  Tbug( string(13, "is written to once per selection.")) 
  TbugTx(13)
  TbugTx(13)
  
PUB Bridge | localCharacter, currentSource, previousSource

  currentSource := -1
  previousSource := -1
  
  Tbug( string(13, "Entering bridge mode."))
  Tbug( string(13, "Put Say It in sleep mode so GUI can wake it."))
  repeat _DefaultWakeAttempts
    Com.tx(_SayItCom, CMD_SLEEP)
    Com.tx(_SayItCom, ARG_ZERO)
  Tbug( string(13, "Enter ", 34, "z", 34, " to end bridge mode."))
  if bridgeComPort == _DebugCom
    Tbug( string(13, 34, "Disable", 34, " Parallax Serial Terminal."))
    Tbug( string(13, "Click ", 34, "Connect", 34, " in the Say It GUI."))
    Tbug( string(13, "When your done with the GUI"))
    Tbug( string(13, "click ", 34, "Disconnect", 34, " in the Say It GUI."))
    Tbug( string(13, 34, "Enable", 34, " Parallax Serial Terminal."))
    Tbug( string(13, "Enter ", 34, "z", 34, " (from Parallax Serial Terminal)"))
    Tbug( string(13, "to end bridge mode."))
                     
  repeat
    localCharacter := Com.rxcheck(_SayItCom)
    if localCharacter <> -1 and localCharacter <> 0
      previousSource := currentSource
      currentSource := _SayItCom
      Com.tx(bridgeComPort, localCharacter)
      if eepromFlag == 1
        if previousSource <> currentSource
          eepromBuffer[ramIndex++] := 13
          eepromBuffer[ramIndex++] := "S"
          eepromBuffer[ramIndex++] := "I"
          eepromBuffer[ramIndex++] := ":"
        eepromBuffer[ramIndex++] := localCharacter   
      if bridgeComPort <> _DebugCom
        if previousSource <> currentSource
          Tbug( string(13, "Say It: "))
        TbugTx(localCharacter)
      
    localCharacter := Com.rxcheck(bridgeComPort)
    if localCharacter <> -1 and localCharacter <> "z" and localCharacter <> 0
      previousSource := currentSource
      currentSource := bridgeComPort
      Com.tx(_SayItCom, localCharacter) 
      if eepromFlag == 1
        if previousSource <> currentSource
          eepromBuffer[ramIndex++] := 13
          eepromBuffer[ramIndex++] := "P"
          eepromBuffer[ramIndex++] := "C"
          eepromBuffer[ramIndex++] := ":"
        eepromBuffer[ramIndex++] := localCharacter
      if bridgeComPort <> _DebugCom
        if previousSource <> currentSource
          Tbug( string(13, "PC: "))
          TbugTx(localCharacter)
      
      
    if bridgeComPort <> _DebugCom  
      localCharacter := Com.rxcheck(_DebugCom)
    if localCharacter == "z"
      Tbug( string(13, "Exiting bridge mode."))
      if ramIndex > 0
        if (eepromIndex + ramIndex) > _EepromEnd
          ramIndex := _EepromEnd - eepromIndex
        Eeprom.FromRam(@eepromBuffer, @eepromBuffer + ramIndex, eepromIndex)
        eepromIndex += ramIndex
        ramIndex := 0  
      waitcnt(clkfreq / 4 + cnt)
      return
    if ramIndex => _EepromTriggerSize
      if (eepromIndex + ramIndex) > _EepromEnd
        ramIndex := _EepromEnd - eepromIndex
      Eeprom.FromRam(@eepromBuffer, @eepromBuffer + ramIndex, eepromIndex)
      eepromIndex += ramIndex
      ramIndex := 0  
{_EepromBegin = $4200
  _EepromEnd = $FFFF}      
PUB Request(localCharacter) | localTemp[2]

  case localCharacter
    "x":
      Tbug( string(13, "Request firmware ID of module."))
      Com.tx(_SayItCom, CMD_ID)
      waitcnt(_TxDelay + cnt)
      result := Com.rxtime(_SayItCom, 1000)
      Tbug( string(13, "firmware ID = "))
      TbugDec(result - ARG_ZERO)
      Tbug( string(", or = "))
      TbugDec(result) 
    "m":
      Tbug( string(13, "Request non-empty groups of module."))
      Com.tx(_SayItCom, CMD_MASK_SD)
      waitcnt(_TxDelay + cnt)
      waitcnt(_TxDelay + cnt)
      waitcnt(_TxDelay + cnt)
      'result := Com.rxtime(_SayItCom, 1000)
      'Tbug( string(13, "non-empty groups = %"))
      Tbug( string(13, "Say It returned = "))
      'TbugBin(result, 8)
      repeat
        result := Com.rxtime(_SayItCom, 1000)
        waitcnt(_TxDelay + cnt)       
        TbugTx(result)
        Tbug(string(" (")) 
        TbugDec(result - ARG_ZERO)
        Tbug(string("), ")) 
        Com.tx(_SayItCom, 32)
        waitcnt(_TxDelay + cnt) 
      while result <> -1 and result <> 0 
    "c":
      Tbug( string(13, "Request count of speaker dependent commands."))
      Com.tx(_SayItCom, CMD_COUNT_SD)
      waitcnt(_TxDelay + cnt)
      waitcnt(_TxDelay + cnt)
      waitcnt(_TxDelay + cnt)
      'result := Com.rxtime(_SayItCom, 1000)
      'Tbug( string(13, "non-empty groups = %"))
      Tbug( string(13, "Say It returned = "))
      'TbugBin(result, 8)
      repeat
        result := Com.rxtime(_SayItCom, 1000)
        waitcnt(_TxDelay + cnt)       
        TbugTx(result)
        Tbug(string(" (")) 
        TbugDec(result - ARG_ZERO)
        Tbug(string("), ")) 
        Com.tx(_SayItCom, 32)
        waitcnt(_TxDelay + cnt) 
      while result <> -1 and result <> 0  
    "p":
      Tbug( string(13, "Reading speaker dependent commands."))
      'Tbug( string(13, "Please enter group index."))
      'Tbug( string(13, "(0 = trigger, 1-15 = generic, 16 = password)"))
      repeat
        Tbug( string(13, "Please enter group index."))
        Tbug( string(13, "(0 = trigger, 1-15 = generic, 16 = password)"))
        localTemp[0] :=  GetNumber
      while localTemp[0] == -1
      Tbug( string(13, "group index = "))
      TbugDec(localTemp[0])
      localTemp[0] += ARG_ZERO
      repeat
        Tbug( string(13, "Please enter command position (0-31)."))
        localTemp[1] :=  GetNumber
      while localTemp[1] == -1
      Tbug( string(13, "command position = "))
      TbugDec(localTemp[1])
      localTemp[1] += ARG_ZERO 
      Com.tx(_SayItCom, CMD_DUMP_SD)
      waitcnt(_TxDelay + cnt)
      Com.tx(_SayItCom, localTemp[0])
      waitcnt(_TxDelay + cnt)
      Com.tx(_SayItCom, localTemp[1])
      waitcnt(_TxDelay + cnt)
      waitcnt(_TxDelay + cnt)
      Tbug( string(13, "Say It returned = "))
      repeat
        result := Com.rxtime(_SayItCom, 1000)
        waitcnt(_TxDelay + cnt)
        TbugTx(result)
        'TbugDec(result - ARG_ZERO)
        'Tbug(string(", "))
        Com.tx(_SayItCom, 32)
        waitcnt(_TxDelay + cnt) 
      while result <> -1 and result <> 0 
      
  waitcnt(clkfreq / 2 + cnt)  
      
PUB SetTimeout | localTemp

  Tbug( string(13, "Set Timeout Method"))
  Tbug( string(13, "The timeout is the amount of time"))
  Tbug( string(13, "the Say It module will wait for a"))
  Tbug( string(13, "word to be said."))
  Tbug( string(13, "Just press Enter to use default."))
  Tbug( string(13, "0 = infinite, 1-30 = seconds"))
  
  Tbug( string(13, "Please enter timeout now."))
  Tbug( string(13, "(Followed by Enter)"))
  Tbug( string(13, "or just Enter for default timeout"))
  Tbug( string(13, "(however long the default is?)"))
  localTemp :=  GetNumber
  
  Tbug( string(13, "timeout = "))
  TbugDec(localTemp)
  localTemp += ARG_ZERO
  Com.tx(_SayItCom, CMD_TIMEOUT)
  waitcnt(_TxDelay + cnt)
  Com.tx(_SayItCom, localTemp)
  waitcnt(_TxDelay + cnt)
  Tbug( string(13, "Say It returned = "))
  repeat                        ' *** possibly change
    result := Com.rxtime(_SayItCom, 1000)
    TbugDec(result)
    if result == STS_SUCCESS
      Tbug( string(13, "Success!"))
    else  
      Tbug(string(", "))
    Com.tx(_SayItCom, 32)
    waitcnt(_TxDelay + cnt)  
  while result <> -1 and result <> 0 
      
  waitcnt(clkfreq / 2 + cnt)
   
PUB FindBranch(localIndex) | localPtr, adjustedIndex, localDigit, localErrorCount

  previousGlobalMode := globalMode
  adjustedIndex := localIndex - ARG_ZERO
 
  case globalMode
    _ListenForWordSet0:
      localPtr := @iWordset0 + (adjustedIndex * _WordsetLabelSize)
      if localIndex == ARG_ZERO
        globalMode := _ListenForWordSet1
      else
        localPtr := @wordError
        Tbug(string(13, "globalMode = _ListenForWordSet0"))
        Tbug(string(13, "An unexpected command was received."))
        Tbug(string(13, "command index = "))
        TbugDec(adjustedIndex)
        Tbug(string(13, "globalMode will not be changed"))
      Tbug( string(13, "Say It heard ", 34)) 
      Tbug(localPtr)
      TbugTx(34)       
    _ListenForWordSet1:
      localPtr := @iWordset1 + (adjustedIndex * _WordsetLabelSize)
      case adjustedIndex
        _ActionWs1:
          globalMode := _ListenForWordSet3
          nextAction := _ActionNext 
          wordset3DigitRemaining := 3
          wordset3Total := 0
          Tbug(string(13, "Action command received."))
          Tbug(string(13, "Waiting for action number to execute."))
        _MoveWs1:
          globalMode := _ListenForWordSet2
          Tbug(string(13, "Move command received."))
          Tbug(string(13, "Waiting for direction to move."))
        _TurnWs1:
          globalMode := _ListenForWordSet2
          Tbug(string(13, "Turn command received."))
          Tbug(string(13, "Waiting for direction to turn."))
        _RunWs1:
          globalMode := _ListenForWordSet3
          nextAction := _RunNext
          wordset3DigitRemaining := 3
          wordset3Total := 0
          Tbug(string(13, "Run command received."))
          Tbug(string(13, "Waiting for program number to run."))
        _LookWs1:
          globalMode := _ListenForWordSet2
          Tbug(string(13, "Look command received."))
          Tbug(string(13, "Waiting for direction to look."))
        _AttackWs1:
          globalMode := _ListenForWordSet2
          Tbug(string(13, "Attack command received."))
          Tbug(string(13, "Waiting for direction to attack."))
        _StopWs1:
          globalMode := _ListenForWordSet0
          nextAction := _StopNext
          Tbug(string(13, "****** STOP!!! ******", 13))
          Tbug(string(13, "(Stop command received.)", 13))
          Tbug(string(13, "Waiting for trigger again."))
        _HelloWs1:
          globalMode := _ListenForWordSet0
          nextAction := _HelloNext
          Tbug(string(13, 13, 13, "****** Hello World!!! ******", 13, 13))
          Tbug(string(13, "Waiting for trigger again."))
        other:
          localPtr := @wordError
          globalMode := _ListenForWordSet0
          Tbug(string(13, "globalMode = _ListenForWordSet1"))
          Tbug(string(13, "An unexpected command was received."))
          Tbug(string(13, "command index = "))
          TbugDec(adjustedIndex)
          Tbug(string(13, "globalMode will be changed _ListenForWordSet0")) 
          Tbug(string(13, "Waiting for trigger again."))
      Tbug( string(13, "Say It heard ", 34)) 
      Tbug(localPtr)
      TbugTx(34)    
    _ListenForWordSet2:
      localPtr := @iWordset2 + (adjustedIndex * _WordsetLabelSize) 
      case adjustedIndex
        _LeftWs2:
          Tbug(string(13, "Left command received."))
          case previousIndex
            _MoveWs1:
              globalMode := _ListenForWordSet3
              nextAction := _MoveLeftNext
              wordset3DigitRemaining := 3
              wordset3Total := 0
              Tbug(string(13, "Waiting for amount to move left."))
            _TurnWs1:
              globalMode := _ListenForWordSet3
              nextAction := _TurnLeftNext
              wordset3DigitRemaining := 3
              wordset3Total := 0
              Tbug(string(13, "Waiting for amount to turn left."))
            _LookWs1:
              globalMode := _ListenForWordSet3
              nextAction := _LookLeftNext   
              wordset3DigitRemaining := 3
              wordset3Total := 0
              Tbug(string(13, "Waiting for amount to look left."))
            _AttackWs1:
              globalMode := _ListenForWordSet3
              nextAction := _AttackLeftNext
              wordset3DigitRemaining := 3
              wordset3Total := 0
              Tbug(string(13, "Waiting for amount to attack left."))
            other:
              localPtr := @wordError
              globalMode := _ListenForWordSet0
              Tbug(string(13, "globalMode = _ListenForWordSet2"))
              Tbug(string(13, "An unexpected command was received."))
              Tbug(string(13, "command index = "))
              TbugDec(adjustedIndex)
              Tbug(string(13, "globalMode will be changed _ListenForWordSet0")) 
              Tbug(string(13, "Waiting for trigger again."))               
        _RightWs2:
          Tbug(string(13, "Right command received."))
          case previousIndex
            _MoveWs1:
              globalMode := _ListenForWordSet3
              nextAction := _MoveRightNext  
              wordset3DigitRemaining := 3
              wordset3Total := 0
              Tbug(string(13, "Waiting for amount to move right."))
            _TurnWs1:
              globalMode := _ListenForWordSet3
              nextAction := _TurnRightNext
              wordset3DigitRemaining := 3
              wordset3Total := 0
              Tbug(string(13, "Waiting for amount to turn right."))
            _LookWs1:
              globalMode := _ListenForWordSet3
              nextAction := _LookRightNext  
              wordset3DigitRemaining := 3
              wordset3Total := 0
              Tbug(string(13, "Waiting for amount to look right."))
            _AttackWs1:
              globalMode := _ListenForWordSet3
              nextAction := _AttackRightNext 
              wordset3DigitRemaining := 3
              wordset3Total := 0
              Tbug(string(13, "Waiting for amount to attack right."))
            other:
              localPtr := @wordError
              globalMode := _ListenForWordSet0
              Tbug(string(13, "globalMode = _ListenForWordSet2"))
              Tbug(string(13, "An unexpected command was received."))
              Tbug(string(13, "command index = "))
              TbugDec(adjustedIndex)
              Tbug(string(13, "globalMode will be changed _ListenForWordSet0")) 
              Tbug(string(13, "Waiting for trigger again."))               
        _UpWs2:
          Tbug(string(13, "Up command received."))
          case previousIndex
            _MoveWs1:
              globalMode := _ListenForWordSet3
              nextAction := _MoveUpNext  
              wordset3DigitRemaining := 3
              wordset3Total := 0
              Tbug(string(13, "Waiting for amount to move up."))
            _TurnWs1:
              globalMode := _ListenForWordSet3
              nextAction := _TurnUpNext
              wordset3DigitRemaining := 3
              wordset3Total := 0
              Tbug(string(13, "Waiting for amount to turn up."))
            _LookWs1:
              globalMode := _ListenForWordSet3
              nextAction := _LookUpNext 
              wordset3DigitRemaining := 3
              wordset3Total := 0
              Tbug(string(13, "Waiting for amount to look up."))
            _AttackWs1:
              globalMode := _ListenForWordSet3
              nextAction := _AttackUpNext
              wordset3DigitRemaining := 3
              wordset3Total := 0
              Tbug(string(13, "Waiting for amount to attack up."))
            other:
              localPtr := @wordError
              globalMode := _ListenForWordSet0
              Tbug(string(13, "globalMode = _ListenForWordSet2"))
              Tbug(string(13, "An unexpected command was received."))
              Tbug(string(13, "command index = "))
              TbugDec(adjustedIndex)
              Tbug(string(13, "globalMode will be changed _ListenForWordSet0")) 
              Tbug(string(13, "Waiting for trigger again."))               
        _DownWs2:
          Tbug(string(13, "Down command received."))
          case previousIndex
            _MoveWs1:
              globalMode := _ListenForWordSet3
              nextAction := _MoveDownNext       
              wordset3DigitRemaining := 3
              wordset3Total := 0
              Tbug(string(13, "Waiting for amount to move down."))
            _TurnWs1:
              globalMode := _ListenForWordSet3
              nextAction := _TurnDownNext
              wordset3DigitRemaining := 3
              wordset3Total := 0
              Tbug(string(13, "Waiting for amount to turn down."))
            _LookWs1:
              globalMode := _ListenForWordSet3
              nextAction := _LookDownNext
              wordset3DigitRemaining := 3
              wordset3Total := 0
              Tbug(string(13, "Waiting for amount to look down."))
            _AttackWs1:
              globalMode := _ListenForWordSet3
              nextAction := _AttackDownNext
              wordset3DigitRemaining := 3
              wordset3Total := 0
              Tbug(string(13, "Waiting for amount to attack down."))
            other:
              localPtr := @wordError
              globalMode := _ListenForWordSet0
              wordset3DigitRemaining := 3
              wordset3Total := 0
              Tbug(string(13, "globalMode = _ListenForWordSet2"))
              Tbug(string(13, "An unexpected command was received."))
              Tbug(string(13, "command index = "))
              TbugDec(adjustedIndex)
              Tbug(string(13, "globalMode will be changed _ListenForWordSet0")) 
              Tbug(string(13, "Waiting for trigger again."))               
        _ForwardWs2:
          Tbug(string(13, "Forward command received."))
          case previousIndex
            _MoveWs1:
              globalMode := _ListenForWordSet3
              nextAction := _MoveForwardNext      
              wordset3DigitRemaining := 3
              wordset3Total := 0
              Tbug(string(13, "Waiting for amount to move forward."))
            _TurnWs1:
              globalMode := _ListenForWordSet3
              nextAction := _TurnForwardNext
              wordset3DigitRemaining := 3
              wordset3Total := 0
              Tbug(string(13, "Waiting for amount to turn forward."))
            _LookWs1:
              globalMode := _ListenForWordSet3
              nextAction := _LookForwardNext
              wordset3DigitRemaining := 3
              wordset3Total := 0
              Tbug(string(13, "Waiting for amount to look forward."))
            _AttackWs1:
              globalMode := _ListenForWordSet3
              nextAction := _AttackForwardNext
              wordset3DigitRemaining := 3
              wordset3Total := 0
              Tbug(string(13, "Waiting for amount to attack forward."))
            other:
              localPtr := @wordError
              globalMode := _ListenForWordSet0
              Tbug(string(13, "globalMode = _ListenForWordSet2"))
              Tbug(string(13, "An unexpected command was received."))
              Tbug(string(13, "command index = "))
              TbugDec(adjustedIndex)
              Tbug(string(13, "globalMode will be changed _ListenForWordSet0")) 
              Tbug(string(13, "Waiting for trigger again."))               
        _BackwardWs2:
          Tbug(string(13, "Backward command received."))
          case previousIndex
            _MoveWs1:
              globalMode := _ListenForWordSet3
              nextAction := _MoveBackwardNext      
              wordset3DigitRemaining := 3
              wordset3Total := 0
              Tbug(string(13, "Waiting for amount to move backward."))
            _TurnWs1:
              globalMode := _ListenForWordSet3
              nextAction := _TurnBackwardNext
              wordset3DigitRemaining := 3
              wordset3Total := 0
              Tbug(string(13, "Waiting for amount to turn backward."))
            _LookWs1:
              globalMode := _ListenForWordSet3
              nextAction := _LookBackwardNext
              wordset3DigitRemaining := 3
              wordset3Total := 0
              Tbug(string(13, "Waiting for amount to look backward."))
            _AttackWs1:
              globalMode := _ListenForWordSet3
              nextAction := _AttackBackwardNext 
              wordset3DigitRemaining := 3
              wordset3Total := 0
              Tbug(string(13, "Waiting for amount to attack backward."))
            other:
              localPtr := @wordError
              globalMode := _ListenForWordSet0
              Tbug(string(13, "globalMode = _ListenForWordSet2"))
              Tbug(string(13, "An unexpected command was received."))
              Tbug(string(13, "command index = "))
              TbugDec(adjustedIndex)
              Tbug(string(13, "globalMode will be changed _ListenForWordSet0")) 
              Tbug(string(13, "Waiting for trigger again."))
      Tbug( string(13, "Say It heard ", 34)) 
      Tbug(localPtr)
      TbugTx(34)
    _ListenForWordSet3:
      wordset3Total := (10 * wordset3Total) + adjustedIndex
      Tbug(string(13, "command index = "))
      TbugDec(adjustedIndex)
      Tbug(string(13, "wordset3Total = "))
      TbugDec(wordset3Total)
      Tbug(string(13, "wordset3DigitRemaining = "))
      TbugDec(--wordset3DigitRemaining)      
      Tbug( string(13, "Say It heard ", 34)) 
      Tbug(localPtr)
      TbugTx(34)
  if wordset3DigitRemaining == 0
    TakeAction
    if globalMode == _ListenForWordSet3
      globalMode := _ListenForWordSet0  
  else
    Tbug(string(13, "wordset3DigitRemaining = "))
    TbugDec(wordset3DigitRemaining)
  
  SetListeningMode(globalMode - _ListenForWordSet0)
    

  if localErrorCount <> 0
    Tbug(string(13, "localErrorCount = "))
    TbugDec(localErrorCount)
          
  priorPreviousIndex := previousIndex
  previousIndex := adjustedIndex
  
{ wordset3DigitRemaining wordset3Total

' mode enumeration
  #0, _ListenForWordSet0, _ListenForWordSet1, _ListenForWordSet2, {
    } _ListenForWordSet3, _NotListening, _ListenForWordSet3Hundreds,  _ListenForWordSet3tens, {
    } _ListenForWordSet3units, _TrainSDGroup0 

  ' wordset1 enumeration
  #0, _ActionWs1, _MoveWs1, _TurnWs1, _RunWs1, _LookWs1, _AttackWs1, _StopWs1, _HelloWs1

  ' wordset2 enumeration
  #0, _LeftWs2, _RightWs2, _UpWs2, _DownWs2, _ForwardWs2, _BackwardWs2

  ' wordset3 enumeration
  #0, _ZeroWs3, _OneWs3, _TwoWs3, _ThreeWs3, _FourWs3, _FiveWs3, _SixWs3, _SevenWs3, _EightWs3, _NineWs3, _TenWs3

}
PUB TakeAction

  case nextAction
    _NoActionNext: return
    _ActionNext:
      Tbug(string(13, "Received command to take action #"))
      TbugDec(wordset3Total)
      Tbug(string(13, "Add a case statement here to direct to "))
      Tbug(string(13, "appropriate action. "))
      nextAction := _NoActionNext     
    _MoveLeftNext:
      Tbug(string(13, "Received command to move left "))
      TbugDec(wordset3Total)
      Tbug(string(" units"))
      Tbug(string(13, "Add method to move appropriate amount. "))
      nextAction := _NoActionNext 
    _MoveRightNext:
      Tbug(string(13, "Received command to move right "))
      TbugDec(wordset3Total)
      Tbug(string(" units"))
      Tbug(string(13, "Add method to move appropriate amount. "))
      nextAction := _NoActionNext 
    _MoveUpNext:
      Tbug(string(13, "Received command to move up "))
      TbugDec(wordset3Total)
      Tbug(string(" units"))
      Tbug(string(13, "Add method to move appropriate amount. "))
      nextAction := _NoActionNext 
    _MoveDownNext:
      Tbug(string(13, "Received command to move down "))
      TbugDec(wordset3Total)
      Tbug(string(" units"))
      Tbug(string(13, "Add method to move appropriate amount. "))
      nextAction := _NoActionNext 
    _MoveForwardNext:
      Tbug(string(13, "Received command to move forward "))
      TbugDec(wordset3Total)
      Tbug(string(" units"))
      Tbug(string(13, "Add method to move appropriate amount. "))
      nextAction := _NoActionNext 
    _MoveBackwardNext:
      Tbug(string(13, "Received command to move backward "))
      TbugDec(wordset3Total)
      Tbug(string(" units"))
      Tbug(string(13, "Add method to move appropriate amount. "))
      nextAction := _NoActionNext 
    _TurnLeftNext:
      Tbug(string(13, "Received command to turn left "))
      TbugDec(wordset3Total)
      Tbug(string(" units"))
      Tbug(string(13, "Add method to turn appropriate amount. "))
      nextAction := _NoActionNext 
    _TurnRightNext:
      Tbug(string(13, "Received command to turn right "))
      TbugDec(wordset3Total)
      Tbug(string(" units"))
      Tbug(string(13, "Add method to turn appropriate amount. "))
      nextAction := _NoActionNext 
    _TurnUpNext:
      Tbug(string(13, "Received command to turn up "))
      TbugDec(wordset3Total)
      Tbug(string(" units"))
      Tbug(string(13, "Add method to turn appropriate amount. "))
      nextAction := _NoActionNext 
    _TurnDownNext:
      Tbug(string(13, "Received command to turn down "))
      TbugDec(wordset3Total)
      Tbug(string(" units"))
      Tbug(string(13, "Add method to turn appropriate amount. "))
      nextAction := _NoActionNext 
    _TurnForwardNext:
      Tbug(string(13, "Received command to turn forward "))
      TbugDec(wordset3Total)
      Tbug(string(" units"))
      Tbug(string(13, "Add method to turn appropriate amount. "))
      nextAction := _NoActionNext 
    _TurnBackwardNext:
      Tbug(string(13, "Received command to turn backward "))
      TbugDec(wordset3Total)
      Tbug(string(" units"))
      Tbug(string(13, "Add method to turn appropriate amount. "))
      nextAction := _NoActionNext 
    _RunNext:
      Tbug(string(13, "Received command to run program #"))
      TbugDec(wordset3Total)
      Tbug(string(13, "Add a case statement here to direct to "))
      Tbug(string(13, "appropriate program. "))
      nextAction := _NoActionNext
    _LookLeftNext:
      Tbug(string(13, "Received command to look left "))
      TbugDec(wordset3Total)
      Tbug(string(" units"))
      Tbug(string(13, "Add method to look appropriate direction. "))
      nextAction := _NoActionNext 
    _LookRightNext:
      Tbug(string(13, "Received command to look right "))
      TbugDec(wordset3Total)
      Tbug(string(" units"))
      Tbug(string(13, "Add method to look appropriate direction. "))
      nextAction := _NoActionNext 
    _LookUpNext:
      Tbug(string(13, "Received command to look up "))
      TbugDec(wordset3Total)
      Tbug(string(" units"))
      Tbug(string(13, "Add method to look appropriate direction. "))
      nextAction := _NoActionNext 
    _LookDownNext:
      Tbug(string(13, "Received command to look down "))
      TbugDec(wordset3Total)
      Tbug(string(" units"))
      Tbug(string(13, "Add method to look appropriate direction. "))
      nextAction := _NoActionNext 
    _LookForwardNext:
      Tbug(string(13, "Received command to look forward "))
      TbugDec(wordset3Total)
      Tbug(string(" units"))
      Tbug(string(13, "Add method to look appropriate direction. "))
      nextAction := _NoActionNext 
    _LookBackwardNext:
      Tbug(string(13, "Received command to look backward "))
      TbugDec(wordset3Total)
      Tbug(string(" units"))
      Tbug(string(13, "Add method to look appropriate direction. "))
      nextAction := _NoActionNext 
    _AttackLeftNext:
      Tbug(string(13, "Received command to attack left "))
      TbugDec(wordset3Total)
      Tbug(string(" units"))
      Tbug(string(13, "Add method to attack appropriate direction. "))
      nextAction := _NoActionNext 
    _AttackRightNext:
      Tbug(string(13, "Received command to attack right "))
      TbugDec(wordset3Total)
      Tbug(string(" units"))
      Tbug(string(13, "Add method to attack appropriate direction. "))
      nextAction := _NoActionNext 
    _AttackUpNext:
      Tbug(string(13, "Received command to attack up "))
      TbugDec(wordset3Total)
      Tbug(string(" units"))
      Tbug(string(13, "Add method to attack appropriate direction. "))
      nextAction := _NoActionNext 
    _AttackDownNext:
      Tbug(string(13, "Received command to attack down "))
      TbugDec(wordset3Total)
      Tbug(string(" units"))
      Tbug(string(13, "Add method to attack appropriate direction. "))
      nextAction := _NoActionNext 
    _AttackForwardNext:
      Tbug(string(13, "Received command to attack forward "))
      TbugDec(wordset3Total)
      Tbug(string(" units"))
      Tbug(string(13, "Add method to attack appropriate direction. "))
      nextAction := _NoActionNext 
    _AttackBackwardNext:
      Tbug(string(13, "Received command to attack backward "))
      TbugDec(wordset3Total)
      Tbug(string(" units"))
      Tbug(string(13, "Add method to attack appropriate direction. "))
      nextAction := _NoActionNext 
    _StopNext:
      Tbug(string(13, "Received command to stop"))
      Tbug(string(13, "Take needed action to stop. "))
      nextAction := _NoActionNext 
    _HelloNext:
      Tbug(string(13, "Received command to say hello."))
      TbugDec(wordset3Total)
      Tbug(string(13, 13, "Hello", 13))
      Tbug(string(13, "One could also add a method to say hello. "))
      nextAction := _NoActionNext 
    
      
PUB WakeUp
  
  Com.tx(_SayItCom, CMD_BREAK)
  result := Com.rxtime(_SayItCom, 1000)

PUB Init : localErrorCount | localCharacter

  localErrorCount := 0
  localCharacter := CMD_LANGUAGE + ARG_ZERO 
  Com.tx(_SayItCom, localCharacter)
  waitcnt(_TxDelay + cnt)
  localCharacter := _English + ARG_ZERO 
  Com.tx(_SayItCom, localCharacter)
  waitcnt(_TxDelay + cnt)
  localCharacter := Com.rxtime(_SayItCom, 2000)
  Tbug(string(13, "Set English language, Say It returned ="))
  TbugTx(localCharacter)
  if localCharacter <> STS_SUCCESS
    Tbug(string(13, "****** Error!!! ******"))
    localErrorCount++
  else
    Tbug(string(13, "Success"))
  waitcnt(clkfreq / 10 + cnt)
  localCharacter := CMD_TIMEOUT
  Com.tx(_SayItCom, localCharacter)
  waitcnt(_TxDelay + cnt)
  localCharacter := ARG_ZERO ' infinite timeout 255 + ARG_ZERO 'default timeout
  Com.tx(_SayItCom, localCharacter)
  waitcnt(_TxDelay + cnt)
  localCharacter := Com.rxtime(_SayItCom, 2000)
  Tbug(string(13, "Set timeout to default, Say It returned ="))
  TbugTx(localCharacter)
  if localCharacter <> STS_SUCCESS
    Tbug(string(13, "****** Error!!! ******"))
    localErrorCount++ 
  else
    Tbug(string(13, "Success"))
  waitcnt(clkfreq / 10 + cnt)
  localCharacter := SetListeningMode(0)
  localErrorCount += localCharacter
  
PUB SetListeningMode(localWordset) : localErrorCount | localCharacter, localPtr, localIndex

  Tbug(string(13, "Listening for wordset ="))
  TbugDec(localWordset)
  Tbug(string(13, "Say one of the following words:"))
  localPtr := @iWordset0
  if localWordset > 0
    repeat localIndex from 0 to localWordset - 1
      localPtr += iSetSize[localIndex] * _WordsetLabelSize
  localIndex := 0
  repeat iSetSize[localWordset]
    TbugTx(13)
    TbugDec(localIndex++)
    TbugTx(")")
    TbugTx(32)
    Tbug(localPtr)
    localPtr += _WordsetLabelSize
  localErrorCount := 0
  Com.tx(_SayItCom, CMD_RECOG_SI)
  waitcnt(_TxDelay + cnt)
  localCharacter := localWordset + ARG_ZERO 
  Com.tx(_SayItCom, localCharacter)
  waitcnt(_TxDelay + cnt)
  globalMode := _ListenForWordSet0 + localWordset
  {localCharacter := Com.rxtime(_SayItCom, 2000)
  Tbug(string(13, "Set wordset to trigger, Say It returned ="))
  TbugTx(localCharacter)
  if localCharacter <> STS_SIMILAR 'STS_SUCCESS 
    Tbug(string(13, "****** Error!!! ******"))
    localErrorCount++
    if localCharacter == STS_TIMEOUT
      Tbug(string(13, "Timeout error was returned."))
      Tbug(string(13, "You might want to increase the timeout."))
      Tbug(string(13, "Set the timeout to zero for infinite timeout."))
    elseif localCharacter == STS_ERROR
      Tbug(string(13, "An error was returned.")) 
  else
    Tbug(string(13, "Success"))
    Tbug(string(13, "The Say It is set to the trigger wordset."))
    globalMode := _ListenForWordSet0
  waitcnt(clkfreq / 10 + cnt)   }
   
PUB GetNumber | localCharacter, numberEnteredFlag
''  Watch out for the abort.  If a method calling this method has
''  the SD card mounted, it needs to have an abort trap located
''  such that the any open files will be closed and the SD card
''  will be unmounted before it exits.

  numberEnteredFlag := 0
  localCharacter := 0
  repeat while numberEnteredFlag == 0
    repeat while localCharacter <> 13
      localCharacter := Com.rx(_DebugCom)
      if localCharacter == "x" or localCharacter == "X"
        Tbug(string("Exiting", 13)) 
        'exitFlag := 1   ' global to exit from a menu
        'abort string("Exit from GetNumber method", 13)
        return -1
      if localCharacter => "0" and localCharacter =< "9"
        result := (result * 10) +  (localCharacter - 48)
        numberEnteredFlag := 1
    
PUB LoadHex(valueToChop, localPtr)
 
  hex(valueToChop, 8, localPtr)

PUB hex(value, digits, localPtr)
'' Print a hexadecimal number
  value <<= (8 - digits) << 2
  repeat digits
    byte[localPtr++] := lookupz((value <-= 4) & $F : "0".."9", "A".."F")
      
PUB FromAsciiHex(digits, localPtr) | localCharacter  

  repeat digits
    localCharacter := byte[localPtr++]
    if localCharacter => "0" and localCharacter =< "9"
      localCharacter -= "0"
    elseif localCharacter => "A" and localCharacter =< "F"
      localCharacter -= "A"
      localCharacter += $0A
    else
      localCharacter := 0
    result <<= 4
    result += localCharacter
     
{PRI FlushBuffer(localBufferIndex) | localCharacter, localIndex, linesOut', previousWirelessCharacter

   if rxFlag[localBufferIndex] == oldRxFlag[localBufferIndex]                              
    Tbug(string(13, "No buffer data, rxFlag["))
    TbugDec(localBufferIndex)
    Tbug(string("] = "))
    TbugDec(rxFlag[localBufferIndex])
    return 0

  'previousWirelessCharacter := 0                        ' I don't think this is used anymore.
  localIndex := 0
  linesOut := linesToExpectCom[localBufferIndex]
  repeat while linesOut > 0
    if localIndex => _LargeBufferSize                   'Header#_LargeBufferSize
      Tbug(string(13, "tempBuffer full!", 13))
      Tbug(string("This shouldn't happen.", 13)) 
      quit
    localCharacter := Com.rxcheck(localBufferIndex)
    if localCharacter == -1
      Tbug(string(13, "rx buffer empty!!!", 13))
      Tbug(string("Data is missing!!!", 13))
      localCharacter := endChar
    tempBuffer[localIndex] := localCharacter
    
    {if localBufferIndex == _WirelessCom
      if localIndex == 0
        'previousWirelessCharacter := localCharacter
      'elseif localIndex == 1 and previousWirelessCharacter == Header#_WirelessAck
       
        'if localCharacter == setCount[xbeeSettings[Header#_TargetSerial]]
        'acknowledgeFlag[xbeeSettings[Header#_TargetSerial]]++
      elseif localIndex == 4
        ' The fifth byte of the message is the setCount value.
        Com.tx(_XBeeCom, Header#_WirelessAck)
        ' check for missed transmission
        'setCount[xbeeSettings[Header#_AttachedSerial
        Com.tx(_XBeeCom, localCharacter)
        Com.tx(_XBeeCom, endChar) }
    if localCharacter == endChar 
      linesOut--
    localIndex++
  tempBuffer[localIndex] := 0   ' is this needed?
  'Tbug(@tempBuffer)
  oldRxFlag[localBufferIndex]++
  SafeBug(@tempBuffer, localIndex)
 
  result := localIndex 
}
PUB SafeBug(localPtr, localSize)

  repeat result from 0 to localSize - 1
    TbugTx(byte[localPtr + result])
      
PRI Tbug(localPtr)

  'Tv.str(localPtr)
  Com.str(_DebugCom, localPtr)
  'Com.str(_BoardC, localPtr)

PRI TbugDec(localDec)

  'Tv.dec(localDec)
  Com.dec(_DebugCom, localDec)
  'Com.dec(_BoardC, localDec)

PRI TbugDecf(localDec, localSize)

  'Tv.decf(localDec, localSize)
  Com.decf(_DebugCom, localDec, localSize)
  'Com.decf(_BoardC, localDec, localSize)

PRI TbugTx(localCharacter)

  if (localCharacter > 31 and localCharacter < 127) or localCharacter == 13
    'Tv.out(localCharacter)
    Com.tx(_DebugCom, localCharacter)
    'Com.tx(_BoardC, localCharacter)
  else
    'Tv.out(60)
    'Tv.out(36)
    Com.tx(_DebugCom, 60)
    Com.tx(_DebugCom, 36)
    'Com.tx(_BoardC, 60)
    'Com.tx(_BoardC, 36)
    TbugHex(localCharacter, 2)
    'Tv.out(62)
    Com.tx(_DebugCom, 62)
    'Com.tx(_BoardC, 62) 
    
PRI TbugHex(localHex, localSize)
 
  'Tv.hex(localHex, localSize)
  Com.hex(_DebugCom, localHex, localSize)
  'Com.hex(_BoardC, localHex, localSize)

PRI TbugBin(localBin, localSize)

  'Tv.bin(localBin, localSize)
  Com.bin(_DebugCom, localBin, localSize)
  'Com.bin(_BoardC, localBin, localSize)
    
DAT
iSetSize      byte _ISetSize0, _ISetSize1, _ISetSize2, _ISetSize3

'' Each word in a wordset has nine characters including trailling zero(s).
              '012345678
iWordset0     byte "robot", 0[4]
         
               '0123456789
iWordset1     byte "action", 0[3]
              byte "move", 0[5]
              byte "turn", 0[5]
              byte "run", 0[6]
              byte "look", 0[5]
              byte "attack", 0[3]
              byte "stop", 0[5]
              byte "hello", 0[4]

iWordset2     byte "left", 0[5]
              byte "right", 0[4]
              byte "up", 0[7]
              byte "down", 0[5]
              byte "forward", 0[2]
              byte "backward", 0
        
iWordset3     byte "zero", 0[5]
              byte "one", 0[6]
              byte "two", 0[6]
              byte "three", 0[4]
              byte "four", 0[5]
              byte "five", 0[5]
              byte "six", 0[6]
              byte "seven", 0[4]
              byte "eight", 0[4]
              byte "nine", 0[5]
              byte "ten", 0[6]


              '012345678
wordError     byte "Error.  Word not found.", 0
                